print("|c00FFCC33 Spellsteal Links -- /sspl for more.|r");
    SSPLDB= {
    ssplonoff = 1,
    SSPLOUTPUT = 'Auto',
    }

local SpellstealPartyLink = CreateFrame("Frame")

local function OnEvent(self, event, ...)
	local dispatch = self[event]

	if dispatch then
		dispatch(self, ...)
	end
end

SpellstealPartyLink:SetScript("OnEvent", OnEvent)
SpellstealPartyLink:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
SpellstealPartyLink:RegisterEvent("ADDON_LOADED")

function SpellstealPartyLink:ADDON_LOADED(...)
	if (event=="ADDON_LOADED") and (arg2=="SpellstealPartyLinks") then
		self:UnregisterEvent("ADDON_LOADED")
		if not SSPLDB then
			SSPLDB= {
			ssplonoff = 1,
			SSPLOUTPUT = 'Auto',
			}
		end
	end
end

function SpellstealPartyLink:COMBAT_LOG_EVENT_UNFILTERED(...)
	local inRealParty = GetNumGroupMembers(LE_PARTY_CATEGORY_HOME)>=1
	local inFakeParty = GetNumGroupMembers(LE_PARTY_CATEGORY_INSTANCE)>=1
	local aEvent = select(2, ...)
	local aUser = select(5, ...)
	local destName = select(9, ...)
	local spellsID = select(15, ...)
	local sspljustfake = "true"
	local ssplrealnfake = "true"
	local sspljustreal = "true"
	local ssplpartytype

	if SSPLDB.ssplonoff==1 then
		if aEvent=="SPELL_STOLEN" then
			if inRealParty and inFakeParty then
				ssplrealnfake = "true"
				ssplpartytype = "Mixed"
				xxx = "INSTANCE_CHAT"
			else
				ssplrealnfake = "false"
			end
			if inRealParty and (not inFakeParty) then
				sspljustreal = "true"
				ssplpartytype = "Real"
				xxx = "INSTANCE_CHAT"
			else
				sspljustreal = "false"
			end
			if (not inRealParty) and inFakeParty then
				sspljustfake = "true"
				ssplpartytype = "Fake"
				xxx = "INSTANCE_CHAT"
				else
				sspljustfake = "false"
			end
			local ssInInstance, ssinstanceType = IsInInstance();
			if ssinstanceType == "pvp" then 
				xxx="INSTANCE_CHAT"
			end
			if aUser~=UnitName("player") then return end 
			local ssplsaymsg = " stole " .. GetSpellLink(spellsID) .. " from " ..destName.. "."
			if SSPLDB.SSPLOUTPUT=='Self' then
				print("|c00FFCC33=> You"..ssplsaymsg)
			elseif SSPLDB.SSPLOUTPUT=='Say' then
				if ssinstanceType == "pvp" then
					print("|c00FFCC33=> You"..ssplsaymsg)
				else
					SendChatMessage("=> I"..ssplsaymsg, "SAY")
				end
			elseif SSPLDB.SSPLOUTPUT=='Auto' then 
				if (not inParty) and (not inRaid) then
					print("|c00FFCC33=> You"..ssplsaymsg)
				else 
					SendChatMessage("=> I"..ssplsaymsg, xxx)
				end
			end
		end
	end 
end

function sspltoggle()
	if SSPLDB.ssplonoff==1 then
		SSPLDB.ssplonoff=0
		print("|c00FFCC33Spellsteal Linker is now off.|r")
	else
		SSPLDB.ssplonoff=1
		print("|c00FFCC33Spellsteal Linker is now on.|r")
	end
end

SLASH_SSPL1="/spl"
SLASH_SSPL1="/sspl"
SlashCmdList["SSPL"] = function(fwah)
local outputlist = " say [] self [] auto |r"
local list = "|c00FFCC33info [] toggle []" ..outputlist
local omgrly = "|c00FFCC33Output is: "
if (fwah == "") then print(list) end
if (fwah == "info") or (fwah == "Info") then print(list)
    if SSPLDB.ssplonoff~=1 then print("|c00FFCC33Spellsteal Linker is off.") else print(omgrly, SSPLDB.SSPLOUTPUT) end end
if (fwah == "toggle") or (fwah == "Toggle") then sspltoggle() end
    if (fwah == "Say") or (fwah == "say") then SSPLDB.SSPLOUTPUT = 'Say' print(omgrly, SSPLDB.SSPLOUTPUT)
    elseif (fwah == "Self") or (fwah == "self") then SSPLDB.SSPLOUTPUT = 'Self' print(omgrly, SSPLDB.SSPLOUTPUT)
    elseif (fwah == "Auto") or (fwah == "auto") then SSPLDB.SSPLOUTPUT = 'Auto' print(omgrly, SSPLDB.SSPLOUTPUT) end
if (fwah~="info")and(fwah~="Info")and(fwah~="")and(fwah~="toggle")and(fwah~="Toggle")and
    (fwah~="Say")and(fwah~="say")and(fwah~="Self")and(fwah~="self")and(fwah~="Auto")and(fwah~="auto")then
    print("Not a valid argument. =( ") end
end
